## dpdk 16.11

=== app/test/Makefile ===
#   BSD LICENSE
#
#   Copyright(c) 2010-2015 Intel Corporation. All rights reserved.
#   All rights reserved.
#
#   Redistribution and use in source and binary forms, with or without
#   modification, are permitted provided that the following conditions
#   are met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in
#       the documentation and/or other materials provided with the
#       distribution.
#     * Neither the name of Intel Corporation nor the names of its
#       contributors may be used to endorse or promote products derived
#       from this software without specific prior written permission.
#
#   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

include $(RTE_SDK)/mk/rte.vars.mk

ifeq ($(CONFIG_RTE_APP_TEST),y)

# default rule
all:

# Define an externally linked resource. A linked resource is an arbitrary
# file that is linked into the test binary. The application refers to this
# resource by name. The linked generates identifiers beg_<name> and end_<name>
# for referencing by the C code.
#
# Parameters: <unique name>, <file to be linked>
define linked_resource
SRCS-y += $(1).res.o
$(1).res.o: $(2)
	@  echo '  MKRES $$@'
	$Q [ "$$(<D)" = . ] || ln -fs $$<
	$Q $(OBJCOPY) -I binary -B $(RTE_OBJCOPY_ARCH) -O $(RTE_OBJCOPY_TARGET) \
		--rename-section                                         \
			.data=.rodata,alloc,load,data,contents,readonly  \
		--redefine-sym _binary_$$(subst .,_,$$(<F))_start=beg_$(1) \
		--redefine-sym _binary_$$(subst .,_,$$(<F))_end=end_$(1)   \
		--redefine-sym _binary_$$(subst .,_,$$(<F))_size=siz_$(1)  \
		$$(<F) $$@
endef

ifeq ($(CONFIG_RTE_APP_TEST_RESOURCE_TAR),y)
define linked_tar_resource
$(1).tar: $(2)
	@  echo '  TAR $$@'
	$Q tar -C $$(dir $$<) -cf $$@ $$(notdir $$<)
$(call linked_resource,$(1),$(1).tar)
endef
else # ! CONFIG_RTE_APP_TEST_RESOURCE_TAR
linked_tar_resource =
endif # CONFIG_RTE_APP_TEST_RESOURCE_TAR

#
# library name
#
APP = test

#
# all sources are stored in SRCS-y
#
SRCS-$(CONFIG_RTE_LIBRTE_CMDLINE) := commands.c
SRCS-y += test.c
SRCS-y += resource.c
SRCS-y += test_resource.c
test_resource.res: test_resource.c
	@ cp $< $@
$(eval $(call linked_resource,test_resource_c,test_resource.res))
$(eval $(call linked_tar_resource,test_resource_tar,test_resource.c))
SRCS-$(CONFIG_RTE_APP_TEST_RESOURCE_TAR) += test_pci.c
$(eval $(call linked_tar_resource,test_pci_sysfs,test_pci_sysfs))
SRCS-y += test_prefetch.c
SRCS-y += test_byteorder.c
SRCS-y += test_per_lcore.c
SRCS-y += test_atomic.c
SRCS-y += test_malloc.c
SRCS-y += test_cycles.c
SRCS-y += test_spinlock.c
SRCS-y += test_memory.c
SRCS-y += test_memzone.c

SRCS-y += test_ring.c
SRCS-y += test_ring_perf.c
SRCS-y += test_pmd_perf.c

ifeq ($(CONFIG_RTE_LIBRTE_TABLE),y)
SRCS-y += test_table.c
SRCS-$(CONFIG_RTE_LIBRTE_PIPELINE) += test_table_pipeline.c
SRCS-y += test_table_tables.c
SRCS-y += test_table_ports.c
SRCS-y += test_table_combined.c
SRCS-$(CONFIG_RTE_LIBRTE_ACL) += test_table_acl.c
endif

SRCS-y += test_rwlock.c

SRCS-$(CONFIG_RTE_LIBRTE_TIMER) += test_timer.c
SRCS-$(CONFIG_RTE_LIBRTE_TIMER) += test_timer_perf.c
SRCS-$(CONFIG_RTE_LIBRTE_TIMER) += test_timer_racecond.c

SRCS-y += test_mempool.c
SRCS-y += test_mempool_perf.c

SRCS-y += test_mbuf.c
SRCS-y += test_logs.c

SRCS-y += test_memcpy.c
SRCS-y += test_memcpy_perf.c

SRCS-$(CONFIG_RTE_LIBRTE_HASH) += test_hash.c
SRCS-$(CONFIG_RTE_LIBRTE_HASH) += test_thash.c
SRCS-$(CONFIG_RTE_LIBRTE_HASH) += test_hash_perf.c
SRCS-$(CONFIG_RTE_LIBRTE_HASH) += test_hash_functions.c
SRCS-$(CONFIG_RTE_LIBRTE_HASH) += test_hash_scaling.c
SRCS-$(CONFIG_RTE_LIBRTE_HASH) += test_hash_multiwriter.c

SRCS-$(CONFIG_RTE_LIBRTE_LPM) += test_lpm.c
SRCS-$(CONFIG_RTE_LIBRTE_LPM) += test_lpm_perf.c
SRCS-$(CONFIG_RTE_LIBRTE_LPM) += test_lpm6.c
SRCS-$(CONFIG_RTE_LIBRTE_LPM) += test_lpm6_perf.c

SRCS-y += test_debug.c
SRCS-y += test_errno.c
SRCS-y += test_tailq.c
SRCS-y += test_string_fns.c
SRCS-y += test_cpuflags.c
SRCS-y += test_mp_secondary.c
SRCS-y += test_eal_flags.c
SRCS-y += test_eal_fs.c
SRCS-y += test_alarm.c
SRCS-y += test_interrupts.c
SRCS-y += test_version.c
SRCS-y += test_func_reentrancy.c

SRCS-$(CONFIG_RTE_LIBRTE_CMDLINE) += test_cmdline.c
SRCS-$(CONFIG_RTE_LIBRTE_CMDLINE) += test_cmdline_num.c
SRCS-$(CONFIG_RTE_LIBRTE_CMDLINE) += test_cmdline_etheraddr.c
SRCS-$(CONFIG_RTE_LIBRTE_CMDLINE) += test_cmdline_portlist.c
SRCS-$(CONFIG_RTE_LIBRTE_CMDLINE) += test_cmdline_ipaddr.c
SRCS-$(CONFIG_RTE_LIBRTE_CMDLINE) += test_cmdline_cirbuf.c
SRCS-$(CONFIG_RTE_LIBRTE_CMDLINE) += test_cmdline_string.c
SRCS-$(CONFIG_RTE_LIBRTE_CMDLINE) += test_cmdline_lib.c

ifeq ($(CONFIG_RTE_LIBRTE_SCHED),y)
SRCS-y += test_red.c
SRCS-y += test_sched.c
endif

SRCS-$(CONFIG_RTE_LIBRTE_METER) += test_meter.c
SRCS-$(CONFIG_RTE_LIBRTE_KNI) += test_kni.c
SRCS-$(CONFIG_RTE_LIBRTE_POWER) += test_power.c test_power_acpi_cpufreq.c
SRCS-$(CONFIG_RTE_LIBRTE_POWER) += test_power_kvm_vm.c
SRCS-y += test_common.c

SRCS-$(CONFIG_RTE_LIBRTE_DISTRIBUTOR) += test_distributor.c
SRCS-$(CONFIG_RTE_LIBRTE_DISTRIBUTOR) += test_distributor_perf.c

SRCS-$(CONFIG_RTE_LIBRTE_REORDER) += test_reorder.c

SRCS-y += test_devargs.c
SRCS-y += virtual_pmd.c
SRCS-y += packet_burst_generator.c
SRCS-$(CONFIG_RTE_LIBRTE_ACL) += test_acl.c

ifeq ($(CONFIG_RTE_LIBRTE_PMD_RING),y)
SRCS-$(CONFIG_RTE_LIBRTE_PMD_BOND) += test_link_bonding.c
SRCS-$(CONFIG_RTE_LIBRTE_PMD_BOND) += test_link_bonding_mode4.c
endif

ifeq ($(CONFIG_RTE_LIBRTE_PMD_NULL),y)
SRCS-$(CONFIG_RTE_LIBRTE_PMD_BOND) += test_link_bonding_rssconf.c
ifeq ($(CONFIG_RTE_BUILD_SHARED_LIB),y)
LDLIBS += -lrte_pmd_null
endif
endif

SRCS-$(CONFIG_RTE_LIBRTE_PMD_RING) += test_pmd_ring.c
SRCS-$(CONFIG_RTE_LIBRTE_PMD_RING) += test_pmd_ring_perf.c

SRCS-$(CONFIG_RTE_LIBRTE_CRYPTODEV) += test_cryptodev_blockcipher.c
SRCS-$(CONFIG_RTE_LIBRTE_CRYPTODEV) += test_cryptodev_perf.c
SRCS-$(CONFIG_RTE_LIBRTE_CRYPTODEV) += test_cryptodev.c

SRCS-$(CONFIG_RTE_LIBRTE_KVARGS) += test_kvargs.c

CFLAGS += -O3
CFLAGS += $(WERROR_FLAGS)

CFLAGS += -D_GNU_SOURCE

LDLIBS += -lm

# Disable VTA for memcpy test
ifeq ($(CONFIG_RTE_TOOLCHAIN_GCC),y)
ifeq ($(shell test $(GCC_VERSION) -ge 44 && echo 1), 1)
CFLAGS_test_memcpy.o += -fno-var-tracking-assignments
CFLAGS_test_memcpy_perf.o += -fno-var-tracking-assignments
endif
endif

# this application needs libraries first
DEPDIRS-y += lib drivers

# Link against shared libraries when needed
ifeq ($(CONFIG_RTE_LIBRTE_PMD_BOND),y)
ifneq ($(CONFIG_RTE_LIBRTE_PMD_RING),y)
$(error Link bonding tests require CONFIG_RTE_LIBRTE_PMD_RING=y)
else
ifeq ($(CONFIG_RTE_BUILD_SHARED_LIB),y)
LDLIBS += -lrte_pmd_ring
endif
endif
endif

ifeq ($(CONFIG_RTE_APP_TEST_RESOURCE_TAR),y)
LDLIBS += -larchive
endif

include $(RTE_SDK)/mk/rte.app.mk

endif

=== examples/cmdline/Makefile ===
#   BSD LICENSE
#
#   Copyright(c) 2010-2014 Intel Corporation. All rights reserved.
#   All rights reserved.
#
#   Redistribution and use in source and binary forms, with or without
#   modification, are permitted provided that the following conditions
#   are met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in
#       the documentation and/or other materials provided with the
#       distribution.
#     * Neither the name of Intel Corporation nor the names of its
#       contributors may be used to endorse or promote products derived
#       from this software without specific prior written permission.
#
#   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

ifeq ($(RTE_SDK),)
$(error "Please define RTE_SDK environment variable")
endif

# Default target, can be overriden by command line or environment
RTE_TARGET ?= x86_64-native-linuxapp-gcc

include $(RTE_SDK)/mk/rte.vars.mk

# binary name
APP = cmdline

# all source are stored in SRCS-y
SRCS-y := main.c commands.c parse_obj_list.c

CFLAGS += -O3
CFLAGS += $(WERROR_FLAGS)
CFLAGS_parse_obj_list.o := -D_GNU_SOURCE

include $(RTE_SDK)/mk/rte.extapp.mk

=== lib/librte_sched/Makefile ===
#   BSD LICENSE
#
#   Copyright(c) 2010-2014 Intel Corporation. All rights reserved.
#   All rights reserved.
#
#   Redistribution and use in source and binary forms, with or without
#   modification, are permitted provided that the following conditions
#   are met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in
#       the documentation and/or other materials provided with the
#       distribution.
#     * Neither the name of Intel Corporation nor the names of its
#       contributors may be used to endorse or promote products derived
#       from this software without specific prior written permission.
#
#   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

include $(RTE_SDK)/mk/rte.vars.mk

#
# library name
#
LIB = librte_sched.a

CFLAGS += -O3
CFLAGS += $(WERROR_FLAGS)

CFLAGS_rte_red.o := -D_GNU_SOURCE

LDLIBS += -lm
LDLIBS += -lrt

EXPORT_MAP := rte_sched_version.map

LIBABIVER := 1

#
# all source are stored in SRCS-y
#
SRCS-$(CONFIG_RTE_LIBRTE_SCHED) += rte_sched.c rte_red.c rte_approx.c
SRCS-$(CONFIG_RTE_LIBRTE_SCHED) += rte_reciprocal.c

# install includes
SYMLINK-$(CONFIG_RTE_LIBRTE_SCHED)-include := rte_sched.h rte_bitmap.h rte_sched_common.h rte_red.h rte_approx.h
SYMLINK-$(CONFIG_RTE_LIBRTE_SCHED)-include += rte_reciprocal.h

# this lib depends upon:
DEPDIRS-$(CONFIG_RTE_LIBRTE_SCHED) += lib/librte_eal
DEPDIRS-$(CONFIG_RTE_LIBRTE_SCHED) += lib/librte_mempool lib/librte_mbuf
DEPDIRS-$(CONFIG_RTE_LIBRTE_SCHED) += lib/librte_net lib/librte_timer

include $(RTE_SDK)/mk/rte.lib.mk

=== drivers/net/cxgbe/Makefile ===
#   BSD LICENSE
#
#   Copyright(c) 2014-2015 Chelsio Communications.
#   All rights reserved.
#
#   Redistribution and use in source and binary forms, with or without
#   modification, are permitted provided that the following conditions
#   are met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in
#       the documentation and/or other materials provided with the
#       distribution.
#     * Neither the name of Chelsio Communications nor the names of its
#       contributors may be used to endorse or promote products derived
#       from this software without specific prior written permission.
#
#   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

include $(RTE_SDK)/mk/rte.vars.mk

#
# library name
#
LIB = librte_pmd_cxgbe.a

CFLAGS += -I$(SRCDIR)/base/
CFLAGS += -I$(SRCDIR)
CFLAGS += -O3
CFLAGS += $(WERROR_FLAGS)

EXPORT_MAP := rte_pmd_cxgbe_version.map

LIBABIVER := 1

ifeq ($(CONFIG_RTE_TOOLCHAIN_ICC),y)
#
# CFLAGS for icc
#
CFLAGS_BASE_DRIVER = -wd188
else
#
# CFLAGS for gcc/clang
#
ifeq ($(CONFIG_RTE_TOOLCHAIN_GCC),y)
ifeq ($(shell test $(GCC_VERSION) -ge 44 && echo 1), 1)
CFLAGS     += -Wno-deprecated
endif
endif
CFLAGS_BASE_DRIVER =

endif

#
# Add extra flags for base driver files (also known as shared code)
# to disable warnings in them
#
BASE_DRIVER_OBJS=$(patsubst %.c,%.o,$(notdir $(wildcard $(SRCDIR)/base/*.c)))
$(foreach obj, $(BASE_DRIVER_OBJS), $(eval CFLAGS_$(obj)+=$(CFLAGS_BASE_DRIVER)))

VPATH += $(SRCDIR)/base


#
# all source are stored in SRCS-y
#
SRCS-$(CONFIG_RTE_LIBRTE_CXGBE_PMD) += cxgbe_ethdev.c
SRCS-$(CONFIG_RTE_LIBRTE_CXGBE_PMD) += cxgbe_main.c
SRCS-$(CONFIG_RTE_LIBRTE_CXGBE_PMD) += sge.c
SRCS-$(CONFIG_RTE_LIBRTE_CXGBE_PMD) += t4_hw.c

# this lib depends upon:
DEPDIRS-$(CONFIG_RTE_LIBRTE_CXGBE_PMD) += lib/librte_eal lib/librte_ether
DEPDIRS-$(CONFIG_RTE_LIBRTE_CXGBE_PMD) += lib/librte_mempool lib/librte_mbuf
DEPDIRS-$(CONFIG_RTE_LIBRTE_CXGBE_PMD) += lib/librte_net

include $(RTE_SDK)/mk/rte.lib.mk

=== debian/changelog ===
dpdk (16.11-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Santiago R.R. <santiagorr@riseup.net>  Wed, 12 Apr 2017 14:47:47 +0200

dpdk (16.11-1) unstable; urgency=medium

  [ Christian Ehrhardt ]
  * Merge stable release 16.11 and adapt patches
    - imported latest stable release from dpdk-16.11.tar.gz
      stable release changelog at
      http://dpdk.org/doc/guides-16.11/rel_notes/release_16_11.html
    - Delete patches that are upstream:
      - d/p/dpdk-dev-ppc-enable-*
      - d/p/dpdk-dev-v2-*-4*
      - d/p/rte-devel-build-env.patch
      - d/p/rte-compile-pre-cppflags.patch
      - d/p/make-load-devel-config-not-to-appear-as-executable.patch
      - d/p/dpdk-dev-doc-fix-old-dpdk-nic-bind.py-references.patch
      - d/p/fix-double-license-info.patch
  * Added changes
    - add qede pmd now built by default
    - add new librte-net library
    - bump librte-eal version from 2 to 3 as package rename transition
    - bump librte-cryptodev version from 1 to 2 as package rename transition
    - bump librte-ethdev version from 4 to 5 and the library rename that was
      made upstream as package rename transition
    - update symbols files to match the new release
    - make autotest dep8 test always pass (failed fatally on e.g. LP).
      We want to stabilize and get more logs of different environments before
      we can enable it as a gating test.

  [ Luca Boccassi ]
  * Set maintainer to pkg-dpdk-dev alioth list
  * Make dpdk suggest dpdk-doc (Closes: #847626)

 -- Luca Boccassi <luca.boccassi@gmail.com>  Fri, 16 Dec 2016 18:19:07 +0000

dpdk (16.07.2-1~git1) UNRELEASED; urgency=medium

  * Merge stable release 16.07.2 and adapt patches
    - imported latest stable release from dpdk-16.07.2.tar.gz
      stable release changelog at
      http://dpdk.org/doc/guides-16.07/rel_notes/release_16_07.html
    - Deleted:
      - d/p/dpdk-dev-v2-kni-fix-build-with-kernel-4.8.patch
      - d/p/fix-unusual-interpreter.patch
      - d/p/dpdk-dev-examples-ip_pipeline-fix-pmd-driver-parameter.patch
      - d/p/dpdk-dev-kni-fix-build-with-kernel-4.9.patch
      - d/p/dpdk-dev-ppc-enable-7-7-examples-ip_pipeline-fix-lcore-mapping-for-
        ppc64.patch
    - Refreshed (only offset changes)
      - d/p/dpdk-dev-ppc-enable-1-7-lpm-add-AltiVec-for-ppc64.patch
      - d/p/dpdk-dev-ppc-enable-2-7-acl-add-AltiVec-for-ppc64.patch
      - d/p/dpdk-dev-ppc-enable-4-7-sched-enable-on-ppc64le.patch
      - d/p/dpdk-dev-ppc-enable-6-7-config-enable-packet-framework-on-
        ppc64le.patch
      - d/p/dpdk-dev-v2-2-4-doc-rendering-and-installation-of-man-pages.patch
      - d/p/dpdk-dev-v2-3-4-doc-add-basic-invocation-info-for-dpdk-pmdinfo.patch
      - d/p/dpdk-dev-v2-4-4-doc-add-basic-invocation-info-for-dpdk-devbind.patch

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Mon, 05 Dec 2016 07:08:01 +0100

dpdk (16.07-3) unstable; urgency=medium

  * Set myself as maintainer until the mailing list ACL problem
    is resolved. (Closes: #843688)

 -- Luca Boccassi <luca.boccassi@gmail.com>  Fri, 25 Nov 2016 23:01:34 +0000

dpdk (16.07-2) unstable; urgency=low

  * Team upload.

  [ Christian Ehrhardt ]
  * Fix d/p/fix-vhost-user-socket-permission.patch for dpdk 16.07
    server/client sockets.
  * d/control add python-elftools and hwdata dependencies to dpdk for the tool
    dpdk-pmdinfo.
  * d/rules utilize RTE_EAL_PMD_PATH to autoload pmd drivers
    - d/dpdk-doc.README.Debian document usage of RTE_EAL_PMD_PATH
    - d/control let the runtime of dpdk recommend the pmd drivers to make them
      available for auto-probing devices.
  * d/rules support DEB_BUILD_OPTIONS parallel
  * d/rules bundle autotest as it is ready after build into dpdk-dev
    to make it available for autopkgtest and likewise developers.
  * enable dpdk autotests
    - d/t/test-autotest enable autotests as dep8 test. These fail in many
      build environments, so put them in an adt where required characteristics
      can be specified

  [ Gowrishankar Muthukrishnan ]
  * d/p/dpdk-dev-examples-ip_pipeline-fix-pmd-driver-parameter.patch to make
    ip_pipeline work properly with -d eal parameter
  * Update to d/p/dpdk-dev-examples-ip_pipeline-fix-pmd-driver-parameter.patch
    fixing dl_open issues.

  [ Santiago R.R. ]
  * debian/rules: Only export hardening related building HOST_/EXTRA flags
    when dpkg-dev < 1.18.11. On newer dpkg-dev versions, dpkg-buildflags
    handle them directly and are injected by gcc (6.x). Closes: #843685.

  [ Luca Boccassi ]
  * Fix DKMS build to use the requested kernel version rather than the running
    one. (Closes: #843864)
  * Fix kernel modules build failures due to the new -fPIE default by passing
    -fno-PIE.
  * Backport dpdk-dev-kni-fix-build-with-kernel-4.9.patch to fix kernel modules
    build failures on Linux 4.9.
  * Mark dpdk-doc as Multi-Arch: foreign
  * Finalize changelog for upload to unstable.

 -- Luca Boccassi <luca.boccassi@gmail.com>  Mon, 14 Nov 2016 18:27:53 +0000

dpdk (16.07-1) unstable; urgency=medium

  [ Christian Ehrhardt ]
  * Merge with upstream DPDK 16.07 release
  * Cleanup Lintian Warnings
    - d/p/fix-unusual-interpreter.patch fixes "W: dpdk-doc:
      unusual-interpreter"
    - d/p/fix-double-license-info.patch fixes "W: dpdk-rte-kni-dkms:
      extra-license-file"
  * Renamed d/p/ubuntu-fix-vhost-user-socket-permission.patch to
    d/p/fix-vhost-user-socket-permission.patch
  * Add lintian-overrides for: E: dpdk-dev: arch-dependent-file-in-usr-share
    These binaries are part of the sdk and meant to be shipped with the sdk.
  * d/p/dpdk-dev-doc-fix-old-dpdk-nic-bind.py-references.patch to fix the
    docs in regard to 16.07 changes renaming dpdk_nic_bind
  * d/p/make-load-devel-config-not-to-appear-as-executable.patch to avoid
    accidentally executing as script and to fix unusual-interpreter lintian
    warning.
  * fix d/t/test-initscripts on more recent systemd environments
  * enable dpdk for ppc64el


=== debian/control ===
Source: dpdk
Priority: optional
Maintainer: Debian DPDK Maintainers <pkg-dpdk-devel@lists.alioth.debian.org>
Uploaders: Luca Boccassi <luca.boccassi@gmail.com>,
           Christian Ehrhardt <christian.ehrhardt@canonical.com>,
           Santiago Ruano Rincón <santiagorr@riseup.net>,
Build-Depends: debhelper (>= 9),
               dh-python,
               dh-systemd (>= 1.5),
               dkms,
               doxygen,
               graphviz,
               inkscape,
               libcap-dev,
               libpcap-dev,
               libxen-dev [amd64 arm64 i386],
               libxenstore3.0 [amd64 arm64 i386],
               python,
               python-sphinx,
               python-sphinx-rtd-theme,
               texlive-fonts-recommended,
               texlive-latex-extra
Standards-Version: 3.9.8
Section: libs
Homepage: http://www.dpdk.org
Vcs-Git: https://gerrit.fd.io/r/deb_dpdk
Vcs-Browser: https://gerrit.fd.io/r/gitweb?p=deb_dpdk.git

Package: dpdk
Section: admin
Architecture: amd64 arm64 i386 ppc64el
Depends: lsb-base (>= 3.2-14),
         pciutils,
         python-pyelftools,
         hwdata,
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends}
Recommends: dpdk-igb-uio-dkms (= ${binary:Version}) [arm64], dpdk-rte-kni-dkms (= ${binary:Version}) [arm64],
         librte-pmd-af-packet1 (= ${binary:Version}),
         librte-pmd-bnxt1 (= ${binary:Version}),
         librte-pmd-bond1 (= ${binary:Version}),
         librte-pmd-cxgbe1 (= ${binary:Version}),
         librte-pmd-e1000-1 (= ${binary:Version}),
         librte-pmd-ena1 (= ${binary:Version}),
         librte-pmd-enic1 (= ${binary:Version}) [amd64 arm64 i386],
         librte-pmd-fm10k1 (= ${binary:Version}) [amd64 i386],
         librte-pmd-i40e1 (= ${binary:Version}) [amd64 i386],
         librte-pmd-ixgbe1 (= ${binary:Version}) [amd64 arm64 i386],
         librte-pmd-null-crypto1 (= ${binary:Version}),
         librte-pmd-null1 (= ${binary:Version}),
         librte-pmd-pcap1 (= ${binary:Version}),
         librte-pmd-ring2 (= ${binary:Version}),
         librte-pmd-vhost1 (= ${binary:Version}),
         librte-pmd-virtio1 (= ${binary:Version}),
         librte-pmd-vmxnet3-uio1 (= ${binary:Version}) [amd64 arm64 i386],
         librte-pmd-xenvirt1 (= ${binary:Version}) [amd64 arm64 i386],
         librte-pmd-qede1 (= ${binary:Version}),
Suggests: linux-image-generic, dpdk-igb-uio-dkms (= ${binary:Version}), dpdk-rte-kni-dkms (= ${binary:Version}), dpdk-doc
Description: Data Plane Development Kit (runtime)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime environment to run DPDK applications.

Package: dpdk-dev
Section: devel
Architecture: amd64 arm64 i386 ppc64el
Depends: libdpdk-dev (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Data Plane Development Kit (development files)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains examples and the upstream build environment. It is
 not strictly required in order to build external applications.

Package: dpdk-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Homepage: http://dpdk.org/doc/guides/index.html
Depends: libjs-jquery, libjs-underscore, ${misc:Depends}, ${python:Depends}
Recommends: python, ${python:Recommends}
Description: Data Plane Development Kit (documentation)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the complete set of documentation and guides.

Package: dpdk-igb-uio-dkms
Section: kernel
Architecture: amd64 arm64 i386 ppc64el
Depends: dkms,
         dpdk-dev (= ${binary:Version}),
         libdpdk-dev (= ${binary:Version}),
         make,
         ${misc:Depends}
Description: Data Plane Development Kit (igb uio dkms)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the source code for the igb_uio kernel module.

Package: dpdk-rte-kni-dkms
Section: kernel
Architecture: amd64 arm64 i386 ppc64el
Depends: dkms,
         dpdk-dev (= ${binary:Version}),
         libdpdk-dev (= ${binary:Version}),
         make,
         ${misc:Depends}
Description: Data Plane Development Kit (rte kni dkms)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the source code for the rte_kni kernel module.

Package: libdpdk-dev
Section: libdevel
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         libpcap-dev,
         librte-ethdev5 (= ${binary:Version}),
         librte-acl2 (= ${binary:Version}),
         librte-cfgfile2 (= ${binary:Version}),
         librte-cmdline2 (= ${binary:Version}),
         librte-cryptodev2 (= ${binary:Version}),
         librte-distributor1 (= ${binary:Version}),
         librte-eal3 (= ${binary:Version}),
         librte-hash2 (= ${binary:Version}),
         librte-ip-frag1 (= ${binary:Version}),
         librte-jobstats1 (= ${binary:Version}),
         librte-kni2 (= ${binary:Version}) [amd64 arm64],
         librte-kvargs1 (= ${binary:Version}),
         librte-lpm2 (= ${binary:Version}),
         librte-mbuf2 (= ${binary:Version}),
         librte-mempool2 (= ${binary:Version}),
         librte-meter1 (= ${binary:Version}),
         librte-pdump1 (= ${binary:Version}),
         librte-pipeline3 (= ${binary:Version}),
         librte-net1 (= ${binary:Version}),
         librte-pmd-af-packet1 (= ${binary:Version}),
         librte-pmd-bnxt1 (= ${binary:Version}),
         librte-pmd-bond1 (= ${binary:Version}),
         librte-pmd-cxgbe1 (= ${binary:Version}),
         librte-pmd-e1000-1 (= ${binary:Version}),
         librte-pmd-ena1 (= ${binary:Version}),
         librte-pmd-enic1 (= ${binary:Version}) [amd64 arm64 i386],
         librte-pmd-fm10k1 (= ${binary:Version}) [amd64 i386],
         librte-pmd-i40e1 (= ${binary:Version}) [amd64 i386],
         librte-pmd-ixgbe1 (= ${binary:Version}) [amd64 arm64 i386],
         librte-pmd-null-crypto1 (= ${binary:Version}),
         librte-pmd-null1 (= ${binary:Version}),
         librte-pmd-pcap1 (= ${binary:Version}),
         librte-pmd-ring2 (= ${binary:Version}),
         librte-pmd-vhost1 (= ${binary:Version}),
         librte-pmd-virtio1 (= ${binary:Version}),
         librte-pmd-vmxnet3-uio1 (= ${binary:Version}) [amd64 arm64 i386],
         librte-pmd-xenvirt1 (= ${binary:Version}) [amd64 arm64 i386],
         librte-pmd-qede1 (= ${binary:Version}),
         librte-port3 (= ${binary:Version}),
         librte-power1 (= ${binary:Version}),
         librte-reorder1 (= ${binary:Version}),
         librte-ring1 (= ${binary:Version}),
         librte-sched1 (= ${binary:Version}),
         librte-table2 (= ${binary:Version}),
         librte-timer1 (= ${binary:Version}),
         librte-vhost3 (= ${binary:Version})
Description: Data Plane Development Kit (basic development files)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the basic headers and library files required to
 build external applications which will also require at least SSE3 support
 when running.

Package: libethdev4
Depends: librte-ethdev5, ${misc:Depends}
Architecture: all
Priority: extra
Section: oldlibs
Description: transitional package
 This is a transitional package. It can safely be removed.

Package: librte-ethdev5
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Homepage: http://dpdk.org/doc/api/rte__ethdev_8h.html
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libdpdk0
Description: Data Plane Development Kit (libethdev runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime libraries for libethdev.

Package: librte-acl2
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Homepage: http://dpdk.org/doc/api/rte__ethdev_8h.html
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libdpdk0
Description: Data Plane Development Kit (librte-acl runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime libraries for librte_acl.

Package: librte-cfgfile2
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Homepage: http://dpdk.org/doc/api/rte__cfgfile_8h.html
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libdpdk0
Description: Data Plane Development Kit (librte-cfgfile runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime libraries for librte_cfgfile.

Package: librte-cmdline2
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libdpdk0
Description: Data Plane Development Kit (librte-cmdline runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime libraries for librte_cmdline.

Package: librte-cryptodev1
Depends: librte-cryptodev2, ${misc:Depends}
Architecture: all
Priority: extra
Section: oldlibs
Description: transitional package
 This is a transitional package. It can safely be removed.

Package: librte-cryptodev2
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Homepage: http://dpdk.org/doc/api/rte__cryptodev_8h.html
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libdpdk0
Description: Data Plane Development Kit (librte-cryptodev runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime libraries for librte_cryptodev.

Package: librte-distributor1
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Homepage: http://dpdk.org/doc/api/rte__distributor_8h.html
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libdpdk0
Description: Data Plane Development Kit (librte-distributor runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime libraries for librte_distributor.

Package: librte-eal2
Depends: librte-eal3, ${misc:Depends}
Architecture: all
Priority: extra
Section: oldlibs
Description: transitional package
 This is a transitional package. It can safely be removed.

Package: librte-eal3
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Homepage: http://dpdk.org/doc/api/rte__eal_8h.html
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libdpdk0
Description: Data Plane Development Kit (librte-eal runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime libraries for librte_eal.

Package: librte-hash2
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
export DH_VERBOSE=1
export DH_OPTIONS=-v

VERSION := $(shell dpkg-parsechangelog | sed -nr '/^Version:/s/Version: (.*:)?(.*)-(.*)/\2/p')

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
include /usr/share/dpkg/default.mk

DEB_HOST_GNU_CPU := $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie

# see ENVIRONMENT in dpkg-buildflags(1)
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# Support backporting to jessie
dpkg_version_lt = $(shell dpkg --compare-versions $$(dpkg --status dpkg-dev | grep Version | cut -d' ' -f2) lt-nl "1.18.11" && echo yes)
ifeq (yes, $(dpkg_version_lt))
	# package maintainers to append CFLAGS
	# For Debian, dpkg-dev >= 1.18.11 and gcc 6.x, dpkg-buildflags and gcc
	# handle -fPIC and related flags relying on specs files
	# (/usr/share/dpkg/*specs)
	export DEB_CFLAGS_MAINT_APPEND  = -fPIC
	export EXTRA_CFLAGS=$(CFLAGS)
	export EXTRA_CPPFLAGS=$(CPPFLAGS)
	export HOST_EXTRA_CFLAGS=$(CFLAGS)
	export HOST_EXTRA_CPPFLAGS=$(CPPFLAGS)
	# need to be stripped as DPDK build system adds them and it would be -Wl,-Wl,opt
	export EXTRA_LDFLAGS=$(shell echo $(LDFLAGS) | sed 's/-Wl,//g')
	# HOST_CC build system does not add -Wl ...
	export EXTRA_HOST_LDFLAGS=$(LDFLAGS)
endif

export RTE_DEVEL_BUILD=n

# People rebuilding this package can overwrite DPDK_CONFIG, RTE_MACHINE and
# RTE_TARGET via DEB_BUILD_OPTIONS if they like
ifneq (,$(filter dpdk_config=%,$(DEB_BUILD_OPTIONS)))
    DPDK_CONFIG ?= $(patsubst dpdk_config=%,%,$(filter dpdk_config=%,$(DEB_BUILD_OPTIONS)))
endif
ifneq (,$(filter rte_machine=%,$(DEB_BUILD_OPTIONS)))
    RTE_MACHINE ?= $(patsubst rte_machine=%,%,$(filter rte_machine=%,$(DEB_BUILD_OPTIONS)))
endif
ifneq (,$(filter rte_target=%,$(DEB_BUILD_OPTIONS)))
    RTE_TARGET ?= $(patsubst rte_target=%,%,$(filter rte_target=%,$(DEB_BUILD_OPTIONS)))
endif

ifneq (,$(filter $(DEB_HOST_ARCH), arm64))
DPDK_CONFIG ?= "arm64-armv8a-linuxapp-gcc"
RTE_MACHINE ?= "armv8a"
RTE_TARGET ?= "arm64-armv8a-linuxapp-gcc"
else
ifneq (,$(filter $(DEB_HOST_ARCH), ppc64el))
DPDK_CONFIG ?= "ppc_64-power8-linuxapp-gcc"
RTE_MACHINE ?= "power8"
RTE_TARGET ?= "ppc_64-power8-linuxapp-gcc"
else
DPDK_CONFIG ?= "$(DEB_HOST_GNU_CPU)-native-linuxapp-gcc"
RTE_MACHINE ?= "default"
RTE_TARGET ?= "$(DEB_HOST_GNU_CPU)-default-linuxapp-gcc"
endif
endif
DPDK_STATIC_DIR = "debian/build/static-root"
DPDK_SHARED_DIR = "debian/build/shared-root"

# now stable with parallel comilation, so support -j
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    PAR := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
    PAR := "1"
endif

# kernel_modules can be passed via DEB_BUILD_OPTIONS to enable building the
# optional binary kernel modules package. By default it will be built against
# the current kernel, or ksrc can be passed with a path to the target kernel
# sources instead.
ifeq (,$(findstring kernel_modules,$(DEB_BUILD_OPTIONS)))
DPDK_CONFIG_BUILD_KMOD=n
KSRC=""
else
ifneq (,$(filter ksrc=%,$(DEB_BUILD_OPTIONS)))
    KSRC := $(patsubst ksrc=%,%,$(filter ksrc=%,$(DEB_BUILD_OPTIONS)))
else
    KSRC := /lib/modules/$(shell uname -r)/build
endif

KVERS := $(shell perl debian/kernel-version $(KSRC))
export KVERS
export MODULE_CFLAGS=-fno-PIE

DPDK_CONFIG_BUILD_KMOD=y

# Since the binary module package is generated at build time depending on the
# local kernel version, we have to append the new package in d/control.
# We cannot use a separate control file since that wouldn't work with
# dpkg-genchanges, and also would require a lot of overrides for debhelpers.
get_built_using	?= $(filter-out (=),$(shell dpkg-query -f='$${source:Package} (=$${source:Version})' -W $1))

override_dh_gencontrol:
	dh_gencontrol
	dh_gencontrol -p dpdk-modules-$(KVERS) -- \
		-v`cat debian/VERSION` \
		-V'built:using:kernel=$(call get_built_using,linux-headers-$(KVERS))'

build:
	@if [ x"$(KVERS)" = x ] ; then \
	    echo 'No version in $(KSRC)/include/linux/version.h' >&2; \
	    exit 1; \
	fi
	sh debian/prep-modules $(KSRC)
	cat debian/control.modules >> debian/control
	dh $@ --with python2,dkms
endif

%:
	dh $@ --with python2,dkms

override_dh_auto_clean:
	rm -rf debian/build debian/tmp debian/dpdk-modules-* \
		debian/control.modules debian/VERSION
	sed -i '/Package: dpdk-modules-/,/`tail -n1 debian/control.modules.in`/d' debian/control
	test -L config/defconfig_$(DPDK_CONFIG) && rm -f config/defconfig_$(DPDK_CONFIG) || true

override_dh_auto_configure:
	# Add support for a custom defconfig file in the debian directory.
ifneq (,$(filter dpdk_config=%,$(DEB_BUILD_OPTIONS)))
	test -e config/defconfig_$(DPDK_CONFIG) || ln -fs ../debian/defconfig_$(DPDK_CONFIG) config/defconfig_$(DPDK_CONFIG)
endif
	# report dpkg-buildflags status to build log
	dpkg-buildflags --status
	echo EXTRA_CFLAGS $$EXTRA_CFLAGS
	echo EXTRA_LDFLAGS: $$EXTRA_LDFLAGS
	$(MAKE) V=$(DH_VERBOSE) O=$(DPDK_STATIC_DIR) T=$(DPDK_CONFIG) config
ifeq (,$(filter dpdk_config=%,$(DEB_BUILD_OPTIONS)))
	sed -ri -e 's,(RTE_MACHINE=).*,\1$(RTE_MACHINE),' \
		-e 's,(RTE_NEXT_ABI=).*,\1n,' \
		-e 's,(CONFIG_RTE_EAL_IGB_UIO=).*,\1$(DPDK_CONFIG_BUILD_KMOD),' \
		-e 's,(CONFIG_RTE_KNI_KMOD=).*,\1$(DPDK_CONFIG_BUILD_KMOD),' \
		-e 's,(LIBRTE_PMD_PCAP=).*,\1y,' \
		-e 's,(LIBRTE_PMD_XENVIRT=).*,\1y,' \
		-e 's,(CONFIG_RTE_EAL_PMD_PATH=).*,\1"/usr/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)/dpdk-pmds/",' \
		$(DPDK_STATIC_DIR)/.config
	# xen not available on ppc64el
ifneq (,$(filter $(DEB_HOST_ARCH), ppc64el))
	sed -ri -e 's,(LIBRTE_PMD_XENVIRT=).*,\1n,' $(DPDK_STATIC_DIR)/.config
endif
endif
	dh_auto_configure

override_dh_auto_build-indep:
	$(MAKE) -j $(PAR) V=$(DH_VERBOSE) O=$(DPDK_STATIC_DIR) doc-api-html doc-guides-html \
		doc-guides-man

override_dh_auto_install-indep:
	# Package: dpdk-doc
	# All files based on the install-doc rule (includes examples)
	$(MAKE) V=$(DH_VERBOSE) O=$(DPDK_STATIC_DIR) prefix=/usr \
		DESTDIR=debian/dpdk-doc install-doc

override_dh_auto_build-arch:
	$(MAKE) -j $(PAR) V=$(DH_VERBOSE) O=$(DPDK_STATIC_DIR) RTE_KERNELDIR=$(KSRC) build
	# Unfortunately the decision about having static or shared libraries is
	# made for the whole build, which then produces only .a or .so files
	# (but not both).
	# And the target layout for target selection has no field for the
	# type of library.
	# Right now I hack this by doing a second build which only differs in
	# the selection of shared libs.
	# Shared libs should be default, so the previous static build is only
	# used to get static libraries.
	cp -a $(DPDK_STATIC_DIR) $(DPDK_SHARED_DIR)
	sed -ri 's,(RTE_BUILD_SHARED_LIB=).*,\1y,' \
		$(DPDK_SHARED_DIR)/.config
	$(MAKE) -j $(PAR) V=$(DH_VERBOSE) O=$(DPDK_SHARED_DIR) RTE_KERNELDIR=$(KSRC) build

override_dh_auto_install-arch: LIBDIR=usr/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
override_dh_auto_install-arch:
	# Package: dpdk (runtime)
	$(MAKE) V=$(DH_VERBOSE) O=$(DPDK_STATIC_DIR) prefix=/usr \
		DESTDIR=debian/dpdk install-runtime
	$(MAKE) V=$(DH_VERBOSE) O=$(DPDK_SHARED_DIR) prefix=/usr \
		DESTDIR=debian/dpdk install-runtime
	mkdir -p debian/dpdk/etc/dpdk
	cp debian/dpdk.interfaces debian/dpdk/etc/dpdk/interfaces
	rm debian/dpdk/usr/sbin/dpdk-devbind
	mkdir -p debian/dpdk/sbin
	ln -s /usr/share/dpdk/tools/dpdk-devbind.py \
		debian/dpdk/sbin/dpdk-devbind
	# Package: dpdk-dev (build environment)
	$(MAKE) V=$(DH_VERBOSE) O=$(DPDK_SHARED_DIR) prefix=/usr \
		DESTDIR=debian/dpdk-dev install-sdk
	cp $(DPDK_SHARED_DIR)/.config debian/dpdk-dev/usr/share/dpdk/config
	sed -e 's/SDK_TARGET/$(RTE_TARGET)/' debian/dpdk-sdk-env.sh.in > \
		debian/dpdk-dev/usr/share/dpdk/dpdk-sdk-env.sh
	# include the bundled autotest suite to be usable from the dpdk-dev package
	mkdir -p debian/dpdk-dev/usr/share/dpdk/test

=== debian/tests/control ===
Tests: test-initscripts
Restrictions: allow-stderr, isolation-machine, needs-root
Depends: dpdk [amd64 arm64 i386 ppc64el], gawk, mount, systemd, sysvinit-utils

Tests: test-linkage
Restrictions: allow-stderr
Depends: libdpdk-dev [amd64 arm64 i386 ppc64el], libc6, libc6-dev, gcc,
 grep, libpcap-dev, libxenstore3.0 [amd64 arm64 i386], pax-utils

Tests: test-dkms
Restrictions: allow-stderr, isolation-machine, needs-root
Depends: kmod, dpdk-igb-uio-dkms [amd64 arm64 i386 ppc64el],
 dpdk-rte-kni-dkms [amd64 arm64 i386 ppc64el]

Tests: test-autotest
Restrictions: allow-stderr, isolation-machine, needs-root
Depends: dpdk-dev, python, python-pexpect
